/**
 * <copyright>
 * </copyright>
 *
 * $Id: FiacreItemProviderAdapterFactory.java,v 1.2 2008-12-12 14:48:46 cbrunett Exp $
 */
package org.topcased.fiacre.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import org.topcased.fiacre.util.FiacreAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class FiacreItemProviderAdapterFactory extends FiacreAdapterFactory
		implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FiacreItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Program} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProgramItemProvider programItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Program}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createProgramAdapter() {
		if (programItemProvider == null) {
			programItemProvider = new ProgramItemProvider(this);
		}

		return programItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.TypeDecl} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TypeDeclItemProvider typeDeclItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.TypeDecl}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTypeDeclAdapter() {
		if (typeDeclItemProvider == null) {
			typeDeclItemProvider = new TypeDeclItemProvider(this);
		}

		return typeDeclItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.ChannelDecl} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ChannelDeclItemProvider channelDeclItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.ChannelDecl}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createChannelDeclAdapter() {
		if (channelDeclItemProvider == null) {
			channelDeclItemProvider = new ChannelDeclItemProvider(this);
		}

		return channelDeclItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.ComponentDecl} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComponentDeclItemProvider componentDeclItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.ComponentDecl}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createComponentDeclAdapter() {
		if (componentDeclItemProvider == null) {
			componentDeclItemProvider = new ComponentDeclItemProvider(this);
		}

		return componentDeclItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.ProcessDecl} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProcessDeclItemProvider processDeclItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.ProcessDecl}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createProcessDeclAdapter() {
		if (processDeclItemProvider == null) {
			processDeclItemProvider = new ProcessDeclItemProvider(this);
		}

		return processDeclItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.ArgumentVariable} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ArgumentVariableItemProvider argumentVariableItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.ArgumentVariable}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createArgumentVariableAdapter() {
		if (argumentVariableItemProvider == null) {
			argumentVariableItemProvider = new ArgumentVariableItemProvider(
					this);
		}

		return argumentVariableItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.LocalVariable} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LocalVariableItemProvider localVariableItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.LocalVariable}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLocalVariableAdapter() {
		if (localVariableItemProvider == null) {
			localVariableItemProvider = new LocalVariableItemProvider(this);
		}

		return localVariableItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Shuffle} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ShuffleItemProvider shuffleItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Shuffle}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createShuffleAdapter() {
		if (shuffleItemProvider == null) {
			shuffleItemProvider = new ShuffleItemProvider(this);
		}

		return shuffleItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Sync} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SyncItemProvider syncItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Sync}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSyncAdapter() {
		if (syncItemProvider == null) {
			syncItemProvider = new SyncItemProvider(this);
		}

		return syncItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Par} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ParItemProvider parItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Par}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createParAdapter() {
		if (parItemProvider == null) {
			parItemProvider = new ParItemProvider(this);
		}

		return parItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Instance} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InstanceItemProvider instanceItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Instance}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInstanceAdapter() {
		if (instanceItemProvider == null) {
			instanceItemProvider = new InstanceItemProvider(this);
		}

		return instanceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.InterfacedComp} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InterfacedCompItemProvider interfacedCompItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.InterfacedComp}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInterfacedCompAdapter() {
		if (interfacedCompItemProvider == null) {
			interfacedCompItemProvider = new InterfacedCompItemProvider(this);
		}

		return interfacedCompItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.State} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StateItemProvider stateItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.State}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createStateAdapter() {
		if (stateItemProvider == null) {
			stateItemProvider = new StateItemProvider(this);
		}

		return stateItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Transition} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TransitionItemProvider transitionItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Transition}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTransitionAdapter() {
		if (transitionItemProvider == null) {
			transitionItemProvider = new TransitionItemProvider(this);
		}

		return transitionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.NullStmt} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NullStmtItemProvider nullStmtItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.NullStmt}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createNullStmtAdapter() {
		if (nullStmtItemProvider == null) {
			nullStmtItemProvider = new NullStmtItemProvider(this);
		}

		return nullStmtItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.WhileStmt} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected WhileStmtItemProvider whileStmtItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.WhileStmt}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createWhileStmtAdapter() {
		if (whileStmtItemProvider == null) {
			whileStmtItemProvider = new WhileStmtItemProvider(this);
		}

		return whileStmtItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.IfStmt} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IfStmtItemProvider ifStmtItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.IfStmt}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIfStmtAdapter() {
		if (ifStmtItemProvider == null) {
			ifStmtItemProvider = new IfStmtItemProvider(this);
		}

		return ifStmtItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Select} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SelectItemProvider selectItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Select}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSelectAdapter() {
		if (selectItemProvider == null) {
			selectItemProvider = new SelectItemProvider(this);
		}

		return selectItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.To} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ToItemProvider toItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.To}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createToAdapter() {
		if (toItemProvider == null) {
			toItemProvider = new ToItemProvider(this);
		}

		return toItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.DeterministicAssignment} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DeterministicAssignmentItemProvider deterministicAssignmentItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.DeterministicAssignment}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDeterministicAssignmentAdapter() {
		if (deterministicAssignmentItemProvider == null) {
			deterministicAssignmentItemProvider = new DeterministicAssignmentItemProvider(
					this);
		}

		return deterministicAssignmentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.NonDeterministicAssignment} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NonDeterministicAssignmentItemProvider nonDeterministicAssignmentItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.NonDeterministicAssignment}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createNonDeterministicAssignmentAdapter() {
		if (nonDeterministicAssignmentItemProvider == null) {
			nonDeterministicAssignmentItemProvider = new NonDeterministicAssignmentItemProvider(
					this);
		}

		return nonDeterministicAssignmentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.SingleAssignment} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SingleAssignmentItemProvider singleAssignmentItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.SingleAssignment}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSingleAssignmentAdapter() {
		if (singleAssignmentItemProvider == null) {
			singleAssignmentItemProvider = new SingleAssignmentItemProvider(
					this);
		}

		return singleAssignmentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.UnExp} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected UnExpItemProvider unExpItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.UnExp}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createUnExpAdapter() {
		if (unExpItemProvider == null) {
			unExpItemProvider = new UnExpItemProvider(this);
		}

		return unExpItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.BinExp} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BinExpItemProvider binExpItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.BinExp}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBinExpAdapter() {
		if (binExpItemProvider == null) {
			binExpItemProvider = new BinExpItemProvider(this);
		}

		return binExpItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.NatLiteral} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NatLiteralItemProvider natLiteralItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.NatLiteral}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createNatLiteralAdapter() {
		if (natLiteralItemProvider == null) {
			natLiteralItemProvider = new NatLiteralItemProvider(this);
		}

		return natLiteralItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.BoolLiteral} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BoolLiteralItemProvider boolLiteralItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.BoolLiteral}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBoolLiteralAdapter() {
		if (boolLiteralItemProvider == null) {
			boolLiteralItemProvider = new BoolLiteralItemProvider(this);
		}

		return boolLiteralItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.VarRef} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected VarRefItemProvider varRefItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.VarRef}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createVarRefAdapter() {
		if (varRefItemProvider == null) {
			varRefItemProvider = new VarRefItemProvider(this);
		}

		return varRefItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.ArrayElem} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ArrayElemItemProvider arrayElemItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.ArrayElem}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createArrayElemAdapter() {
		if (arrayElemItemProvider == null) {
			arrayElemItemProvider = new ArrayElemItemProvider(this);
		}

		return arrayElemItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.RecordElem} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RecordElemItemProvider recordElemItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.RecordElem}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRecordElemAdapter() {
		if (recordElemItemProvider == null) {
			recordElemItemProvider = new RecordElemItemProvider(this);
		}

		return recordElemItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.InlineQueue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InlineQueueItemProvider inlineQueueItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.InlineQueue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInlineQueueAdapter() {
		if (inlineQueueItemProvider == null) {
			inlineQueueItemProvider = new InlineQueueItemProvider(this);
		}

		return inlineQueueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.BoolType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BoolTypeItemProvider boolTypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.BoolType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBoolTypeAdapter() {
		if (boolTypeItemProvider == null) {
			boolTypeItemProvider = new BoolTypeItemProvider(this);
		}

		return boolTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.NatType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NatTypeItemProvider natTypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.NatType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createNatTypeAdapter() {
		if (natTypeItemProvider == null) {
			natTypeItemProvider = new NatTypeItemProvider(this);
		}

		return natTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.IntType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IntTypeItemProvider intTypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.IntType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIntTypeAdapter() {
		if (intTypeItemProvider == null) {
			intTypeItemProvider = new IntTypeItemProvider(this);
		}

		return intTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Interval} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IntervalItemProvider intervalItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Interval}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIntervalAdapter() {
		if (intervalItemProvider == null) {
			intervalItemProvider = new IntervalItemProvider(this);
		}

		return intervalItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Record} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RecordItemProvider recordItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Record}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRecordAdapter() {
		if (recordItemProvider == null) {
			recordItemProvider = new RecordItemProvider(this);
		}

		return recordItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Field} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FieldItemProvider fieldItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Field}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFieldAdapter() {
		if (fieldItemProvider == null) {
			fieldItemProvider = new FieldItemProvider(this);
		}

		return fieldItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Array} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ArrayItemProvider arrayItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Array}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createArrayAdapter() {
		if (arrayItemProvider == null) {
			arrayItemProvider = new ArrayItemProvider(this);
		}

		return arrayItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Queue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected QueueItemProvider queueItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Queue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createQueueAdapter() {
		if (queueItemProvider == null) {
			queueItemProvider = new QueueItemProvider(this);
		}

		return queueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.TypeId} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TypeIdItemProvider typeIdItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.TypeId}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTypeIdAdapter() {
		if (typeIdItemProvider == null) {
			typeIdItemProvider = new TypeIdItemProvider(this);
		}

		return typeIdItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.ChannelId} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ChannelIdItemProvider channelIdItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.ChannelId}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createChannelIdAdapter() {
		if (channelIdItemProvider == null) {
			channelIdItemProvider = new ChannelIdItemProvider(this);
		}

		return channelIdItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Profile} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProfileItemProvider profileItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Profile}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createProfileAdapter() {
		if (profileItemProvider == null) {
			profileItemProvider = new ProfileItemProvider(this);
		}

		return profileItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.OrChannel} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OrChannelItemProvider orChannelItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.OrChannel}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createOrChannelAdapter() {
		if (orChannelItemProvider == null) {
			orChannelItemProvider = new OrChannelItemProvider(this);
		}

		return orChannelItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.InlineArray} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InlineArrayItemProvider inlineArrayItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.InlineArray}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInlineArrayAdapter() {
		if (inlineArrayItemProvider == null) {
			inlineArrayItemProvider = new InlineArrayItemProvider(this);
		}

		return inlineArrayItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.InlineRecord} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InlineRecordItemProvider inlineRecordItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.InlineRecord}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInlineRecordAdapter() {
		if (inlineRecordItemProvider == null) {
			inlineRecordItemProvider = new InlineRecordItemProvider(this);
		}

		return inlineRecordItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.ValuedField} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ValuedFieldItemProvider valuedFieldItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.ValuedField}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createValuedFieldAdapter() {
		if (valuedFieldItemProvider == null) {
			valuedFieldItemProvider = new ValuedFieldItemProvider(this);
		}

		return valuedFieldItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Synchronization} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SynchronizationItemProvider synchronizationItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Synchronization}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSynchronizationAdapter() {
		if (synchronizationItemProvider == null) {
			synchronizationItemProvider = new SynchronizationItemProvider(this);
		}

		return synchronizationItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Reception} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReceptionItemProvider receptionItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Reception}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createReceptionAdapter() {
		if (receptionItemProvider == null) {
			receptionItemProvider = new ReceptionItemProvider(this);
		}

		return receptionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Emission} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EmissionItemProvider emissionItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Emission}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEmissionAdapter() {
		if (emissionItemProvider == null) {
			emissionItemProvider = new EmissionItemProvider(this);
		}

		return emissionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Seq} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SeqItemProvider seqItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Seq}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSeqAdapter() {
		if (seqItemProvider == null) {
			seqItemProvider = new SeqItemProvider(this);
		}

		return seqItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.LocalPortDecl} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LocalPortDeclItemProvider localPortDeclItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.LocalPortDecl}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLocalPortDeclAdapter() {
		if (localPortDeclItemProvider == null) {
			localPortDeclItemProvider = new LocalPortDeclItemProvider(this);
		}

		return localPortDeclItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.ParamPortDecl} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ParamPortDeclItemProvider paramPortDeclItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.ParamPortDecl}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createParamPortDeclAdapter() {
		if (paramPortDeclItemProvider == null) {
			paramPortDeclItemProvider = new ParamPortDeclItemProvider(this);
		}

		return paramPortDeclItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Priority} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PriorityItemProvider priorityItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Priority}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPriorityAdapter() {
		if (priorityItemProvider == null) {
			priorityItemProvider = new PriorityItemProvider(this);
		}

		return priorityItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.ConstrExp} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConstrExpItemProvider constrExpItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.ConstrExp}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createConstrExpAdapter() {
		if (constrExpItemProvider == null) {
			constrExpItemProvider = new ConstrExpItemProvider(this);
		}

		return constrExpItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Union} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected UnionItemProvider unionItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Union}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createUnionAdapter() {
		if (unionItemProvider == null) {
			unionItemProvider = new UnionItemProvider(this);
		}

		return unionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.ConstrPattern} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConstrPatternItemProvider constrPatternItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.ConstrPattern}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createConstrPatternAdapter() {
		if (constrPatternItemProvider == null) {
			constrPatternItemProvider = new ConstrPatternItemProvider(this);
		}

		return constrPatternItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.ArrayPattern} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ArrayPatternItemProvider arrayPatternItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.ArrayPattern}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createArrayPatternAdapter() {
		if (arrayPatternItemProvider == null) {
			arrayPatternItemProvider = new ArrayPatternItemProvider(this);
		}

		return arrayPatternItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.FieldPattern} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FieldPatternItemProvider fieldPatternItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.FieldPattern}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFieldPatternAdapter() {
		if (fieldPatternItemProvider == null) {
			fieldPatternItemProvider = new FieldPatternItemProvider(this);
		}

		return fieldPatternItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.AnyPattern} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AnyPatternItemProvider anyPatternItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.AnyPattern}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAnyPatternAdapter() {
		if (anyPatternItemProvider == null) {
			anyPatternItemProvider = new AnyPatternItemProvider(this);
		}

		return anyPatternItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.CaseStmt} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CaseStmtItemProvider caseStmtItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.CaseStmt}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCaseStmtAdapter() {
		if (caseStmtItemProvider == null) {
			caseStmtItemProvider = new CaseStmtItemProvider(this);
		}

		return caseStmtItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Rule} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RuleItemProvider ruleItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Rule}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRuleAdapter() {
		if (ruleItemProvider == null) {
			ruleItemProvider = new RuleItemProvider(this);
		}

		return ruleItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.RefArg} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RefArgItemProvider refArgItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.RefArg}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRefArgAdapter() {
		if (refArgItemProvider == null) {
			refArgItemProvider = new RefArgItemProvider(this);
		}

		return refArgItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.ConstantDecl} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConstantDeclItemProvider constantDeclItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.ConstantDecl}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createConstantDeclAdapter() {
		if (constantDeclItemProvider == null) {
			constantDeclItemProvider = new ConstantDeclItemProvider(this);
		}

		return constantDeclItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.ConstantRef} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConstantRefItemProvider constantRefItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.ConstantRef}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createConstantRefAdapter() {
		if (constantRefItemProvider == null) {
			constantRefItemProvider = new ConstantRefItemProvider(this);
		}

		return constantRefItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Constr} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConstrItemProvider constrItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Constr}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createConstrAdapter() {
		if (constrItemProvider == null) {
			constrItemProvider = new ConstrItemProvider(this);
		}

		return constrItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.FiniteBound} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FiniteBoundItemProvider finiteBoundItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.FiniteBound}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFiniteBoundAdapter() {
		if (finiteBoundItemProvider == null) {
			finiteBoundItemProvider = new FiniteBoundItemProvider(this);
		}

		return finiteBoundItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.InfiniteBound} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InfiniteBoundItemProvider infiniteBoundItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.InfiniteBound}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInfiniteBoundAdapter() {
		if (infiniteBoundItemProvider == null) {
			infiniteBoundItemProvider = new InfiniteBoundItemProvider(this);
		}

		return infiniteBoundItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.CondExp} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CondExpItemProvider condExpItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.CondExp}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCondExpAdapter() {
		if (condExpItemProvider == null) {
			condExpItemProvider = new CondExpItemProvider(this);
		}

		return condExpItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.topcased.fiacre.model.Foreach} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ForeachItemProvider foreachItemProvider;

	/**
	 * This creates an adapter for a {@link org.topcased.fiacre.model.Foreach}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createForeachAdapter() {
		if (foreachItemProvider == null) {
			foreachItemProvider = new ForeachItemProvider(this);
		}

		return foreachItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory
				.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(
			ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class)
					|| (((Class<?>) type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (programItemProvider != null)
			programItemProvider.dispose();
		if (typeDeclItemProvider != null)
			typeDeclItemProvider.dispose();
		if (channelDeclItemProvider != null)
			channelDeclItemProvider.dispose();
		if (componentDeclItemProvider != null)
			componentDeclItemProvider.dispose();
		if (processDeclItemProvider != null)
			processDeclItemProvider.dispose();
		if (argumentVariableItemProvider != null)
			argumentVariableItemProvider.dispose();
		if (localVariableItemProvider != null)
			localVariableItemProvider.dispose();
		if (shuffleItemProvider != null)
			shuffleItemProvider.dispose();
		if (syncItemProvider != null)
			syncItemProvider.dispose();
		if (parItemProvider != null)
			parItemProvider.dispose();
		if (instanceItemProvider != null)
			instanceItemProvider.dispose();
		if (interfacedCompItemProvider != null)
			interfacedCompItemProvider.dispose();
		if (stateItemProvider != null)
			stateItemProvider.dispose();
		if (transitionItemProvider != null)
			transitionItemProvider.dispose();
		if (nullStmtItemProvider != null)
			nullStmtItemProvider.dispose();
		if (whileStmtItemProvider != null)
			whileStmtItemProvider.dispose();
		if (ifStmtItemProvider != null)
			ifStmtItemProvider.dispose();
		if (selectItemProvider != null)
			selectItemProvider.dispose();
		if (toItemProvider != null)
			toItemProvider.dispose();
		if (deterministicAssignmentItemProvider != null)
			deterministicAssignmentItemProvider.dispose();
		if (nonDeterministicAssignmentItemProvider != null)
			nonDeterministicAssignmentItemProvider.dispose();
		if (singleAssignmentItemProvider != null)
			singleAssignmentItemProvider.dispose();
		if (unExpItemProvider != null)
			unExpItemProvider.dispose();
		if (binExpItemProvider != null)
			binExpItemProvider.dispose();
		if (natLiteralItemProvider != null)
			natLiteralItemProvider.dispose();
		if (boolLiteralItemProvider != null)
			boolLiteralItemProvider.dispose();
		if (varRefItemProvider != null)
			varRefItemProvider.dispose();
		if (arrayElemItemProvider != null)
			arrayElemItemProvider.dispose();
		if (recordElemItemProvider != null)
			recordElemItemProvider.dispose();
		if (inlineQueueItemProvider != null)
			inlineQueueItemProvider.dispose();
		if (boolTypeItemProvider != null)
			boolTypeItemProvider.dispose();
		if (natTypeItemProvider != null)
			natTypeItemProvider.dispose();
		if (intTypeItemProvider != null)
			intTypeItemProvider.dispose();
		if (intervalItemProvider != null)
			intervalItemProvider.dispose();
		if (recordItemProvider != null)
			recordItemProvider.dispose();
		if (fieldItemProvider != null)
			fieldItemProvider.dispose();
		if (arrayItemProvider != null)
			arrayItemProvider.dispose();
		if (queueItemProvider != null)
			queueItemProvider.dispose();
		if (typeIdItemProvider != null)
			typeIdItemProvider.dispose();
		if (channelIdItemProvider != null)
			channelIdItemProvider.dispose();
		if (profileItemProvider != null)
			profileItemProvider.dispose();
		if (orChannelItemProvider != null)
			orChannelItemProvider.dispose();
		if (inlineArrayItemProvider != null)
			inlineArrayItemProvider.dispose();
		if (inlineRecordItemProvider != null)
			inlineRecordItemProvider.dispose();
		if (valuedFieldItemProvider != null)
			valuedFieldItemProvider.dispose();
		if (synchronizationItemProvider != null)
			synchronizationItemProvider.dispose();
		if (receptionItemProvider != null)
			receptionItemProvider.dispose();
		if (emissionItemProvider != null)
			emissionItemProvider.dispose();
		if (seqItemProvider != null)
			seqItemProvider.dispose();
		if (localPortDeclItemProvider != null)
			localPortDeclItemProvider.dispose();
		if (paramPortDeclItemProvider != null)
			paramPortDeclItemProvider.dispose();
		if (priorityItemProvider != null)
			priorityItemProvider.dispose();
		if (constrExpItemProvider != null)
			constrExpItemProvider.dispose();
		if (unionItemProvider != null)
			unionItemProvider.dispose();
		if (constrPatternItemProvider != null)
			constrPatternItemProvider.dispose();
		if (arrayPatternItemProvider != null)
			arrayPatternItemProvider.dispose();
		if (fieldPatternItemProvider != null)
			fieldPatternItemProvider.dispose();
		if (anyPatternItemProvider != null)
			anyPatternItemProvider.dispose();
		if (caseStmtItemProvider != null)
			caseStmtItemProvider.dispose();
		if (ruleItemProvider != null)
			ruleItemProvider.dispose();
		if (refArgItemProvider != null)
			refArgItemProvider.dispose();
		if (constantDeclItemProvider != null)
			constantDeclItemProvider.dispose();
		if (constantRefItemProvider != null)
			constantRefItemProvider.dispose();
		if (constrItemProvider != null)
			constrItemProvider.dispose();
		if (finiteBoundItemProvider != null)
			finiteBoundItemProvider.dispose();
		if (infiniteBoundItemProvider != null)
			infiniteBoundItemProvider.dispose();
		if (condExpItemProvider != null)
			condExpItemProvider.dispose();
		if (foreachItemProvider != null)
			foreachItemProvider.dispose();
	}

}
